img = ones(100,100);
img = 100*img;
img(25:74, 25:74) = 200*ones(50,50);

img = ones(400,400);
img2 = rgb2gray(imread('xray.png'));

%img = imnoise(img,'gaussian',0,0.1); 

img2 = double(img2);
img(1:200, 1:200) = img2;
img(201:400, 201:400) = img2;
%imagesc(img)
%colormap('gray');

colormap('jet');

sig = 1;
alpha = 1;
beta = 0.1;
dt = 1;

phi = 0*ones(length(img),length(img));

epsilon = 100;
epsilongradphi = 0.0001;
gimg = g(img,sig);
Niter = 10;
for i = 1:Niter
   [gradphix, gradphiy] = gradient(phi);
   normgradphi = sqrt(sqrt(gradphix .^2 + gradphiy .^2) .^2 + epsilongradphi^2);
   freg = divergence(gradphix ./normgradphi,gradphiy ./normgradphi);
   
   fimg = f(img,phi);
   fadapt = gimg .* fimg ;
   
   if mod(i,2)==0
    ax1= subplot(1,2,1);
    colormap(ax1,'gray');
    imagesc(img);
    
    %contour(phi < epsilon & phi > - epsilon);
    %subplot(1,3,2);
    colormap('jet');
    hold on;
    contour(phi,1,'LineColor',[1,0,0], 'LineWidth',2);
    %surf(phi < epsilon & phi > - epsilon);
    %imagesc(phi < epsilon & phi > - epsilon);
    subplot(1,2,2);
    surf(downsample(phi,5));
    drawnow;
   end
   phi = phi + dt*(alpha*fadapt + beta*freg);
end

%%FUNCTIONS
function y = c1(img,phi)
    himg = heaviside(phi);
    sumhimg = sum(sum(himg));
    if sumhimg ~= 0
        y = sum(sum(himg .* img)) ./ sumhimg;
    else
        y = mean(mean(img));
    end
end

function y = c2(img,phi)
    himg = heaviside(-1 .* phi);
    sumhimg = sum(sum(himg));
    if sumhimg ~= 0
        y = sum(sum(himg .* img)) ./ sumhimg;
    else
        y = mean(mean(img));
    end
end

function y = f(img,phi)
    y = sign(img - (c1(img,phi) + c2(img,phi))/2);
end

function y = g(img,sig)
    [gradx, grady] = gradient(imgaussfilt(img,sig));
    y = exp(-sqrt(gradx .^2 + grady .^2) ./ 20);
end
